import { Message } from 'eris';
import { Client, Command } from '../class';

export default class AddPromoCode extends Command {
  constructor(client: Client) {
    super(client);
    this.name = 'addpromo';
    this.description = 'Creates a new promotional code for Stripe.';
    this.usage = `${this.client.config.prefix}addpromo <stripe PC API id>`;
    this.aliases = ['promo', 'ap'];
    this.permissions = 6;
    this.guildOnly = true;
    this.enabled = true;
  }

  public async run(message: Message, args: string[]) {
    if (!args[0]) return this.client.commands.get('help').run(message, [this.name]);
    try {
      const pcd = await this.client.stripe.promotionCodes.retrieve(args[0]);
      const promo = new this.client.db.mongo.Promo({
        code: pcd.code,
        pID: args[0],
      });
      await promo.save();
    } catch (err) {
      return this.error(message.channel, 'Promotional API ID doesn\'t exist.');
    }
  }
}
